module.exports =
/******/ (function(modules) { // webpackBootstrap
/******/ 	// The module cache
/******/ 	var installedModules = {};

/******/ 	// The require function
/******/ 	function __webpack_require__(moduleId) {

/******/ 		// Check if module is in cache
/******/ 		if(installedModules[moduleId])
/******/ 			return installedModules[moduleId].exports;

/******/ 		// Create a new module (and put it into the cache)
/******/ 		var module = installedModules[moduleId] = {
/******/ 			exports: {},
/******/ 			id: moduleId,
/******/ 			loaded: false
/******/ 		};

/******/ 		// Execute the module function
/******/ 		modules[moduleId].call(module.exports, module, module.exports, __webpack_require__);

/******/ 		// Flag the module as loaded
/******/ 		module.loaded = true;

/******/ 		// Return the exports of the module
/******/ 		return module.exports;
/******/ 	}


/******/ 	// expose the modules object (__webpack_modules__)
/******/ 	__webpack_require__.m = modules;

/******/ 	// expose the module cache
/******/ 	__webpack_require__.c = installedModules;

/******/ 	// __webpack_public_path__
/******/ 	__webpack_require__.p = "";

/******/ 	// Load entry module and return exports
/******/ 	return __webpack_require__(0);
/******/ })
/************************************************************************/
/******/ ([
/* 0 */
/***/ function(module, exports, __webpack_require__) {

	module.exports = __webpack_require__(1);


/***/ },
/* 1 */
/***/ function(module, exports, __webpack_require__) {

	/// <reference path="Grib2Data.ts" />
	/// <reference path="Grid.ts" />
	/// <reference path="Interpolate.ts" />
	"use strict";

	const Grid_ts_1 = __webpack_require__(2);
	Object.defineProperty(exports, "__esModule", { value: true });
	exports.default = Grid_ts_1.build;

/***/ },
/* 2 */
/***/ function(module, exports, __webpack_require__) {

	/// <reference path="Grib2Data.ts" />
	/// <reference path="Interpolate.ts" />
	"use strict";

	const Grib2Data_ts_1 = __webpack_require__(3);
	const Interpolate_ts_1 = __webpack_require__(4);
	function floorMod(a, n) {
	    const f = a - n * Math.floor(a / n);
	    // HACK: when a is extremely close to an n transition, f can be equal to n. This is bad because f must be
	    //       within range [0, n). Check for this corner case. Example: a:=-1e-16, n:=10. What is the proper fix?
	    return f === n ? 0 : f;
	}
	function isValue(x) {
	    return x != null && x != undefined;
	}
	function makeField(header, grid, interpolate) {
	    const λ0 = header.lo1;
	    const φ0 = header.la1;
	    const Δλ = header.dx;
	    const Δφ = header.dy;
	    return (λ, φ) => {
	        const i = floorMod(λ - λ0, 360) / Δλ;
	        const j = (φ0 - φ) / Δφ;
	        const fi = Math.floor(i);
	        const ci = fi + 1;
	        const fj = Math.floor(j);
	        const cj = fj + 1;
	        let row;
	        if (row = grid[fj]) {
	            const g00 = row[fi];
	            const g10 = row[ci];
	            if (isValue(g00) && isValue(g10) && (row = grid[cj])) {
	                const g01 = row[fi];
	                const g11 = row[ci];
	                if (isValue(g01) && isValue(g11)) {
	                    // All four points found, so interpolate the value.
	                    return interpolate({
	                        x: i - fi,
	                        y: j - fj,
	                        g00: g00,
	                        g10: g10, g01: g01, g11: g11
	                    });
	                }
	            }
	        }
	        console.warn("cannot interpolate: " + λ + "," + φ + ": " + fi + " " + ci + " " + fj + " " + cj);
	        return null;
	    };
	}
	function makeGrid(accessor, ni, nj, isContinuous) {
	    let grid = [];
	    let p = 0;
	    for (let j = 0; j < nj; ++j) {
	        let row = [];
	        for (let i = 0; i < ni; ++i, ++p) {
	            row[i] = accessor(p);
	        }
	        if (isContinuous) {
	            row.push(row[0]);
	        }
	        grid[j] = row;
	    }
	    return grid;
	}
	function build(data, interpolateFunc = Interpolate_ts_1.bilinearInterpolateVector) {
	    const header1 = data.segments[0].header;
	    const accessor = idx => data.segments.map(segment => segment.data[idx]);
	    const dataSource = Grib2Data_ts_1.getDataSource(header1);
	    const date = new Date(header1.refTime);
	    date.setHours(date.getHours() + header1.forecastTime);
	    const isContinuous = Math.floor(header1.nx * header1.dx) >= 360;
	    const grid = makeGrid(accessor, header1.nx, header1.ny, isContinuous);
	    const field = makeField(header1, grid, interpolateFunc);
	    return {
	        grid: grid,
	        date: date,
	        dataSource: dataSource,
	        field: field
	    };
	}
	exports.build = build;

/***/ },
/* 3 */
/***/ function(module, exports) {

	"use strict";

	function getDataSource(header) {
	    switch (header.center || header.centerName) {
	        case -3:
	            return "OSCAR / Earth & Space Research";
	        case 7:
	        case "US National Weather Service, National Centres for Environmental Prediction (NCEP)":
	            return "GFS / NCEP / US National Weather Service";
	        default:
	            return header.centerName;
	    }
	}
	exports.getDataSource = getDataSource;

/***/ },
/* 4 */
/***/ function(module, exports) {

	"use strict";

	function bilinearInterpolateScalar(p) {
	    const rx = 1 - p.x;
	    const ry = 1 - p.y;
	    return p.g00 * rx * ry + p.g10 * p.x * ry + p.g01 * rx * p.y + p.g11 * p.x * p.y;
	}
	exports.bilinearInterpolateScalar = bilinearInterpolateScalar;
	function bilinearInterpolateVector(p) {
	    const rx = 1 - p.x;
	    const ry = 1 - p.y;
	    const a = rx * ry;
	    const b = p.x * ry;
	    const c = rx * p.y;
	    const d = p.x * p.y;
	    const u = p.g00[0] * a + p.g10[0] * b + p.g01[0] * c + p.g11[0] * d;
	    const v = p.g00[1] * a + p.g10[1] * b + p.g01[1] * c + p.g11[1] * d;
	    return [u, v, Math.sqrt(u * u + v * v)];
	}
	exports.bilinearInterpolateVector = bilinearInterpolateVector;

/***/ }
/******/ ]);